
;(module sieve)
(define from (lambda (n) 
	       (cons n (lambda () (from (+ n 1))))))

(define ltake (lambda (n xs)
	       (cond ((null? xs) xs)
		     ((zero? n) '())
		     (else (cons (car xs) (ltake (- n 1) ((cdr xs))))))))


(define (lfilter p xs)
  (cond ((null? xs) '())
	((p (car xs))  (cons (car xs) (lambda () (lfilter p ((cdr xs))))))
	(else (lfilter p ((cdr xs))))))

(define (relprime p) (lambda (n) (> (remainder n p) 0)))

(define (sieve xs) (cons (car xs) 
			 (lambda() 
			   (sieve (lfilter (relprime (car xs)) ((cdr xs)))))))


(define primes (sieve (from 2)))

(define (last xs)
  (cond ((null? xs) xs)
	((null? (cdr xs)) xs)
	(else (last (cdr xs)))))

(let ((n (read))
      (args (argv)))
  (display args) (newline)
  (if (> n 1) 
    (if (equal? (cadr args) "t") 
      (begin (display (ltake n primes)) (newline) #t)
      (begin (display (car (last (ltake n primes)))) (newline) #t))))



