open OS
datatype 'a stream = Nil | Cons of 'a * (unit->'a stream)

fun from n = Cons(n,fn()=> from (n+1))

fun ltake (0,_) = []
  | ltake (_,Nil) = []
  | ltake (n,Cons (x,xs)) = x :: ltake (n-1,xs())

fun lfilter (p,Nil) = Nil
  | lfilter (p, Cons (x,xs)) = if p(x) 
				then Cons (x, fn () => lfilter (p, xs()))
				else lfilter(p, xs())
fun sieve (Cons(p,xs)) = Cons (p,fn()=> sieve (lfilter(fn x=> x mod p > 0, xs())) )

val primes = sieve (from 2)

fun last [] = []
  | last [x] = [x]
  | last (a::b::xs) = last (b::xs)

open OS 
open TextIO
open Int

fun read () = let val (SOME x) = inputLine stdIn;
		  val (SOME n) = fromString x
	      in n end; 


fun printlist ([] : string list) = print "\n"
  | printlist [x] = print (x^"\n")
  | printlist (x::xs) = (print (x^"::"); printlist xs)

fun main (cmd : string, args : string list) = 
	if hd(args) = "t"
	then ( 	printlist args;
		let val n = read ()
		in printlist (map toString (ltake (n,primes))) end;
		OS.Process.success)
	else ( 	printlist args;
		let val n = read ()
		in print ((toString(hd(last (ltake (n,primes))))) ^ "\n") end;
		OS.Process.success)

	
	
